Connectors (Integrations)
In Nylas, a connector (formerly called an "integration") stores information that allows your Nylas application to connect to a third party services, such as a provider auth application from Google (GCP), Microsoft (Azure), or to an IMAP provider. You must create a connector in your Nylas application for each specific provider before you can create Grants and access user data from that provider.
A Nylas connector stores data about how your Nylas application contacts the provider, the default permissions the Nylas application requests, and is generally the starting point for any authentication with that provider.
Connector contents
The connector stores a label provided by the user, the provider name or type (for example, google/microsoft/imap/virtual_calendar), an expiry time for the hosted authentication link, and the provider settings.
The "provider's settings" come from the provider itself when you create your provider auth application on Google, Azure, or IMAP. For example, a provider's settings might contain the provider auth application's client_id and client_secret. Nylas stores these values securely and uses them as default credentials when authenticating with that provider.
Nylas follows modern security best practices to encode and encrypt these provider settings, to ensure that they can never be obtained by a third party, including Nylas internal employees.
What are limitations of connectors?
Connectors are associated with a single Nylas application.
You can have only one Nylas connector for each type of provider. For example, your Nylas application can have only one Google connector.
If you want to create a grant for a different provider auth application, (for example, on a different GCP project, but you already have a default Google connector), you can create additional credentials for your connector. Each connector can have multiple credentials, where each credential represents a different provider auth application. For more information, see Using multiple provider applications.
GET /v3/connectorsList the connectors in your Nylas application.
POST /v3/connectorsCreate a connector in your Nylas application. Connectors are how your Nylas application stores information it needs to connect to external services. Creating a connector is the first step in setting u...
GET /v3/connectors/{provider}Returns a connector for the specified provider.
PATCH /v3/connectors/{provider}Update the connector for the specified provider. When you make a PATCH request, Nylas replaces all data in the nested object with the information included in your request. For more information, see Up...
DELETE /v3/connectors/{provider}Delete the existing connector for the provider you specify.
POST /v3/providers/detectReturns the provider if one is detected. This operation is rate limited to 20 calls per minute for each Nylas application ID.